<script>
import {mapActions, mapGetters, mapMutations} from "vuex";
import scrollama from "scrollama";
import "intersection-observer";
import axios from "axios";
import actions from "../../store/actionsDataNarrator";
import getters from "../../store/gettersDataNarrator";
import mutations from "../../store/mutationsDataNarrator";

export default {
    name: "DipasPlayer",
    model: {
        prop: "currentStepIndex",
        event: "change"
    },
    props: {
        storyConfPath: {
            type: String,
            default: null
        },
        // All steps of the current story
        steps: {
            type: Array,
            default: null
        }
    },
    data () {
        return {
            currentIndex: 0,
            loadedContent: null
        };
    },
    computed: {
        ...mapGetters("Tools/DataNarrator", Object.keys(getters)),
        ...mapGetters(["uiStyle"])
    },
    created () {
        this.steps.forEach((step) => {
            this.loadStoryContents(step.htmlFile).then(data => {
                this.$set(step, "loadedContent", data);
            }).catch(err => {
                console.error(err);
            });
        });
    },
    mounted () {
        // We need to alter the tool window corresponding to the uiStyle
        let toolWindowClass = "tool-window-vue";

        if (this.uiStyle === "TABLE") {
            toolWindowClass = "table-tool-win-all-vue";
        }
        const toolWindow = document.getElementsByClassName(toolWindowClass)[0],
            heading = toolWindow.getElementsByClassName("win-heading")[0],
            scrollyButton = toolWindow.getElementsByClassName("scrolly-button")[0],
            dataNarratorReset = document.getElementById("tool-dataNarrator-reset"),
            toolBody = document.getElementById("vue-tool-content-body"),
            scroller = scrollama();

        toolWindow.style.setProperty("background-color", "transparent", "important");
        toolWindow.style.boxShadow = "none";
        toolWindow.style.height = "100%";
        heading.style = "display: none;";
        toolBody.style = "height: 100%; background-color: transparent !important; -ms-overflow-style: none; overflow: overlay; max-height: 100%; padding: 0;";
        if (scrollyButton) {
            scrollyButton.style = "display: none;";
        }
        if (dataNarratorReset) {
            dataNarratorReset.style = "display: none;";
        }

        // Setup the instance, pass callback functions
        scroller
            .setup({
                step: ".stepper"
            })
            .onStepEnter((response) => {
                this.currentIndex = response.index;
                this.$emit("change", response.index);
            })
            .onStepExit(() => {
                this.currentIndex = null;
            });

        document.getElementsByClassName("stepper")[0].scrollIntoView({block: "center"});
    },
    methods: {
        ...mapMutations("Tools/DataNarrator", Object.keys(mutations)),
        ...mapActions("Tools/DataNarrator", Object.keys(actions)),

        /**
         * Updates the step html content
         * @param {Object} htmlFile name of the html file to load
         * @returns {void}
         */
        async loadStoryContents (htmlFile) {
            if (this.storyConf.htmlFolder && htmlFile) {
                const storybasepath = this.storyConfPath.endsWith("/") ? this.storyConfPath : this.storyConfPath + "/",
                    response = await axios.get(storybasepath + this.storyConf.htmlFolder + "/" + htmlFile),
                    data = await response.data;

                return data;
            }
            return null;

        }
    }
};
</script>

<template>
    <div
        id="dipasplayer"
    >
        <div
            v-for="(step, index) in steps"
            :key="step.title"
            class="stepper"
            :class="{ active: index === currentIndex}"
        >
            <img
                alt="step title image"
                :src="step.titleImage"
            >

            <h1 v-if="step.title">
                {{ step.title }}
            </h1>

            <div
                class="tool-dataNarrator-content"
            >
                <div
                    v-html="step.loadedContent"
                />
            </div>
        </div>
    </div>
</template>

<style lang="scss">
#vue-tool-content-body::-webkit-scrollbar {
    width: 0 !important;
    background: transparent; /* make scrollbar transparent */
}
</style>

<style lang="scss" scoped>

@import "../../../../../css/mixins.scss";

#dipasplayer {

    width: var(--initialToolWidth);
    @media (max-width: 767px) {
        width: var(--initialToolWidthMobile);
    }

    .stepper {
        min-height: 450px;
        margin: 200px 0;
        background-color: transparent !important;

        img {
            width: 100%;
            object-fit: cover;
        }

        h1 {
            padding: 20px 40px;
        }

        .tool-dataNarrator-content {
            overflow: auto;
            padding: 20px 40px;

            img {
                width: 100%;
            }
        }
    }

    .stepper.active {
        background-color: white !important;
        box-shadow: 0 4px 8px 0 rgb(0 0 0 / 50%);
    }
}
</style>
